backend/models/UserRestaurantBooking.php
<?php

namespace backend\models;

use Yii;
use backend\models\Users;
use backend\models\UserRestaurantManage;

/**
 * This is the model class for table "user_restaurant_booking".
 *
 * @property string $pkUserRestaurantBookingID
 * @property string $fkRestaurantID
 * @property string $fkUserID
 * @property string $userRestaurantQRCode
 * @property integer $userNumberSeats
 * @property integer $waitingTime
 * @property integer $buzzInTime
 * @property string $date
 * @property integer $userCancelBookong
 *
 * @property Users $fkUser
 * @property Restaurant $fkRestaurant
 */
class UserRestaurantBooking extends \yii\db\ActiveRecord
{
    public $bookingId;
    public $timeValue;
    public $userId;
    public $isVip;
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'user_restaurant_booking';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['fkRestaurantID', 'fkUserID', 'userNumberSeats', 'waitingTime', 'buzzInTime', 'userCancelBookong'], 'integer'],
            [['date','timestamp','bookingId', 'timeValue','userId','isVip'], 'safe'],
            [['userRestaurantQRCode'], 'string', 'max' => 100],
            [['fkUserID'], 'exist', 'skipOnError' => true, 'targetClass' => Users::className(), 'targetAttribute' => ['fkUserID' => 'pkUserID']],
            [['fkRestaurantID'], 'exist', 'skipOnError' => true, 'targetClass' => Restaurant::className(), 'targetAttribute' => ['fkRestaurantID' => 'pkRestaurantID']],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'pkUserRestaurantBookingID' => 'Pk User Restaurant Booking ID',
            'fkRestaurantID' => 'Fk Restaurant ID',
            'fkUserID' => 'Fk User ID',
            'userRestaurantQRCode' => 'User Restaurant Qrcode',
            'userNumberSeats' => 'User Number Seats',
            'waitingTime' => 'Waiting Time',
            'buzzInTime' => 'Buzz In Time',
            'date' => 'Date',
            'bookingId' => 'bookingId',
            'userCancelBookong' => 'User Cancel Bookong',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getFkUser()
    {
        return $this->hasOne(Users::className(), ['pkUserID' => 'fkUserID']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getFkRestaurant()
    {
        return $this->hasOne(Restaurant::className(), ['pkRestaurantID' => 'fkRestaurantID']);
    }

    public function getFkUserManage()
    {
        return $this->hasOne(UserRestaurantManage::className(), ['fkRestaurantID' => 'fkRestaurantID']);
    }


    public function updateTime($params)
    {
        $this->load(array('UserRestaurantBooking' => $params));
        // return $params;
        //$bookingId = $this->bookingId;

        $result = self::findOne(['pkUserRestaurantBookingID' => $this->bookingId]);

        if($result)
        {
             $result->waitingTime = $this->timeValue;
             if($result->save()){
                return 'changed';
             }else{
                return false;
             }
        }

    }

    public function updateVip($params)
    {

        $this->load(array('UserRestaurantBooking' => $params));
        $result = Users::find()->where(['pkUserID' => $this->userId])->one();
        if($result)
        {
            $result->userVip = $this->isVip;

            if($result->save())
            {
                if($this->isVip == '0')
                {
                    return 'notVip';

                }elseif($this->isVip == '1')
                {
                    return 'vip';
                }
                
            }
            else
            {
                return false;
            }
        }
    }

    public function createRestaurantBooking()
    {
        $postValues = Yii::$app->request->post();
        //echo '<pre>'; print_r($postValues); echo '</pre>';
        //die;

        $userId = (isset($postValues['userId'])) ? $postValues['userId'] : NULL ;
        $restaurantId = (isset($postValues['restaurantId'])) ? $postValues['restaurantId'] : NULL ;
        $todayDate = date("Y-m-d");
        $timestamp = time();

        $this->fkUserID = $userId;
        $this->fkRestaurantID = $restaurantId;
        $this->date = $todayDate;
        $this->timestamp = $timestamp;

        if($this->save())
        {
            return true;
        }
        else
        {
            return false;
        }
    }
}

backend/controllers/UserRestaurantBookingController.php
<?php

namespace backend\controllers;

use Yii;
use backend\models\UserRestaurantBooking;
use backend\models\UserRestaurantBookingSearch;
use backend\models\Restaurant;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\filters\AccessControl;

/**
 * UserRestaurantBookingController implements the CRUD actions for UserRestaurantBooking model.
 */
class UserRestaurantBookingController extends Controller
{
    public $request;
    public $enableCsrfValidation = false;

    /**
     * @inheritdoc
     */
    // public function behaviors()
    // {
    //     return [
    //         'verbs' => [
    //             'class' => VerbFilter::className(),
    //             'actions' => [
    //                 'delete' => ['POST'],
    //             ],
    //         ],
    //     ];
    // }

    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        'actions' => ['login','signup', 'error','update-time','update-vip','restaurant-details'],
                        'allow' => true,
                    ],
                    [
                        'actions' => ['view', 'index','create','update','delete','update-time','update-vip','restaurant-details','transactions'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
              /*  'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['post'],
                ],
            ],*/
          ];
    }

    /**
     * Lists all UserRestaurantBooking models.
     * @return mixed
     */
    public function actionIndex()
    {
        $searchModel = new UserRestaurantBookingSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    public function actionTransactions()
    {
        $searchModel = new UserRestaurantBookingSearch();
        $dataProvider = $searchModel->searchTransaction(Yii::$app->request->queryParams);

        return $this->render('transaction', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }


    public function actionUpdateTime()
    {
        
        $values = Yii::$app->request->post();
        $model = new UserRestaurantBooking();
        $response = $model->updateTime($values);
        return $response;
    }

    public function actionUpdateVip()
    {
        
        $values = Yii::$app->request->post();
        // print_r($values);
        // die;
        $model = new UserRestaurantBooking();
        $response = $model->updateVip($values);
        return $response;
    }

    public function actionRestaurantDetails()
    {
        $restaurantID = Yii::$app->request->post('restaurantId');

        if(isset( $restaurantID ))
        {
          $response = Restaurant::findOne($restaurantID); 

          if($response)
          {
              return \yii\helpers\Json::encode($response);
          }
        }
        else
        {
          return false;
        }
      
    }
    /**
     * Displays a single UserRestaurantBooking model.
     * @param string $id
     * @return mixed
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModelCustom($id),
        ]);

    }

    /**
     * Creates a new UserRestaurantBooking model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new UserRestaurantBooking();
        if ($model->load(Yii::$app->request->post()) && $model->createRestaurantBooking()) {
            return $this->redirect(['view', 'id' => $model->pkUserRestaurantBookingID]);
        } else {
            return $this->render('create', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Updates an existing UserRestaurantBooking model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param string $id
     * @return mixed
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->pkUserRestaurantBookingID]);
        } else {
            return $this->render('update', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Deletes an existing UserRestaurantBooking model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param string $id
     * @return mixed
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the UserRestaurantBooking model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param string $id
     * @return UserRestaurantBooking the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = UserRestaurantBooking::findOne($id)) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }

    protected function findModelCustom($id)
    {
        if (($model = UserRestaurantBooking::find()->joinWith(['fkUser','fkRestaurant'])->where(['user_restaurant_booking.pkUserRestaurantBookingID' => $id])->one()) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }

}

backend/views/user-restaurant-booking/_form.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use yii\helpers\ArrayHelper;
use backend\models\Users;
use backend\models\Restaurant;

/* @var $this yii\web\View */
/* @var $model backend\models\UserRestaurantBooking */
/* @var $form yii\widgets\ActiveForm */
$currentuserId = Yii::$app->user->getId();
$restaurants = Restaurant::find()->joinWith(['restaurantCity','restaurantLocation','userRestaurantManages'])->where(['user_restaurant_manage.fkUserRestaurantOwnerID' => $currentuserId])->all();
//echo '<pre>'; print_r($restaurants); echo '</pre>'; die;
?>
<div class="col-sm-9 col-sm-offset-3 col-md-10 col-md-offset-2 main">.
<h1><?php echo $this->title;?></h1>
              <div class="content-area restaurant">
                  <div class="row">
                      

                      <div class="col-lg-10 col-md-10">
                          <form class="booking_details" method="post">
                          <?php $form = ActiveForm::begin(); ?>
                              <div class="fieldBox name">
                                    <div class="row">
                                        <div class="col-xs-4">
                                            <input placeholder="Select User" type="text" disabled>
                                        </div>
                                        <div class="col-xs-4">
                                        <select name="userId">
                                        <option>--Select User--</option>
                                        <?php $users = Users::find()->all();
                                        
                                        if($users)
                                        { 
                                            foreach($users as $user){
                                            ?>
                                        <option value="<?php if(@$user){ echo $user->pkUserID;} ?>"><?php echo $user->userName.'('.$user->userNumber.')'; ?></option>
                                        <?php
                                        }
                                        }
                                        ?>
                                        </select>
                                        </div>
                                    </div>
                              </div>

                              <!-- <div class="fieldBox date-book">
                                <div class="row">
                                    <div class="col-xs-4">
                                        <div class="styled-select slate">
                                            <select disabled>
                                                <option>Date of booking</option>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="col-xs-4">
                                        <span>09-Aug-2016</span>
                                    </div>
                                </div>
                              </div> -->

                              <div class="fieldBox restaurant-name">
                                <div class="row">
                                    <div class="col-xs-4">
                                        <input placeholder="Restaurant" type="text" disabled>
                                    </div>
                                    <div class="col-xs-4">
                                        <select name="restaurantId"  id="restaurantNames">
                                        <option>--Select Restaurant--</option>                                        
                                       <?php
                                        if($restaurants)
                                        { 
                                            foreach($restaurants as $restaurant){
                                            ?>
                                        <option value="<?php if(@$restaurant){ echo $restaurant->pkRestaurantID;} ?>"><?php echo $restaurant->restaurantName.' ('.$restaurant->restaurantCity->cityName.', '.$restaurant->restaurantLocation->locationName.')'; ?></option>
                                        <?php
                                        }
                                        }
                                        ?>
                                        </select>
                                    </div>
                                </div>
                              </div>

                              <!-- <div class="fieldBox email">
                                <div class="row">
                                    <div class="col-xs-4">
                                        <input placeholder="Email" type="text" disabled>
                                    </div>
                                    <div class="col-xs-4">
                                        <span>info@gmail.com</span>
                                    </div>
                                </div>
                              </div> -->

                              <!-- <div class="fieldBox phone">
                                <div class="row">
                                    <div class="col-xs-4">
                                        <input placeholder="Phone No" type="text" disabled>
                                    </div>
                                    <div class="col-xs-4">
                                        <span>983937893</span>
                                    </div>
                                </div>
                              </div> -->

                              <!-- <div class="fieldBox time">
                                <div class="row">
                                    <div class="col-xs-4">
                                        <div class="styled-select slate">
                                            <select disabled>
                                                <option>Time</option>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="col-xs-4">
                                        <span>09:30 PM</span>
                                    </div>
                                </div>
                              </div> -->
                              
                              <div class="fieldBox time">
                                <div class="row">
                                    <div class="col-xs-4">
                                        <div class="styled-select slate">
                                            <select disabled>
                                                <option>Waiting Time</option>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="col-xs-6">
                                        <span>
                                        <?= $form->field($model, 'waitingTime')->textInput()->input('text',['id' => 'restaurantWaiting'])->label(false); ?>
                                        <!-- <input type="text" name="waitingTime" id="restaurantWaiting"> --></span>
                                    </div>
                                    
                                </div>
                              </div>
                              <div class="fieldBox current-wait">
                                <div class="row">
                                    <div class="col-xs-4">
                                        <div class="styled-select slate">
                                            <select disabled>
                                                <option>Number of Seats</option>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="col-xs-6">
                                        <span>
                                    <?= $form->field($model, 'userNumberSeats')->textInput()->input('text')->label(false); ?>
                                    </span>
                                    </div>
                                    
                                </div>
                              </div>

                              <!-- <div class="fieldBox rewards">
                                <div class="row">
                                    <div class="col-xs-4">
                                        <input placeholder="Rewards" type="text" disabled>
                                    </div>
                                    <div class="col-xs-6">
                                        <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit</p>
                                    </div>
                                    <div class="col-xs-2 text-right">
                                        <a href="#"><img src="common/images/edit-icon.png" alt="EDIT"/></a>
                                    </div>
                                </div>
                              </div> -->
                              <div class="row">
                                <div class="btnBox col-lg-3 pull-right">
                                    <input class="btn" value="<?php if($model->isNewRecord){echo 'Submit';}else{echo 'Update';}?>" id="restaurantSubmit" type="submit">
                                </div>
                              </div>
                          </form>
                      </div>
                  </div>
              </div>
               <div class="coptyright">BuzzQ © 2016. All Rights Reserved.</div>
        </div>
    <?php ActiveForm::end(); ?>

backend/views/user-restaurant-booking/_search.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use yii\helpers\ArrayHelper;
use backend\models\Restaurant;

/* @var $this yii\web\View */
/* @var $model backend\models\SearchReservations */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="content-area search-bookig">
    <h2>Search</h2>

    <?php
    $form = ActiveForm::begin([
                'action' => ['index'],
                'method' => 'get',
    ]);
    ?>
    <div class="row">
        <div class="col-lg-4 col-sm-4">
            <div class="fieldBox booking-id">

<?php
echo $form->field($model, 'pkUserRestaurantBookingID')->textInput()->input('text', ['placeholder' => "Booking ID"])->label(false);
?>
            </div>   
        </div>

        <div class="col-lg-4 col-sm-4">
            <div class="fieldBox name">

<?php
echo $form->field($model, 'userName')->textInput()->input('text', ['placeholder' => "Name"])->label(false);
?>

            </div>   
        </div>

        <div class="col-lg-4 col-sm-4">
            <div class="fieldBox time">
               
<?php
echo $form->field($model, 'waitingTime')->textInput()->input('text', ['placeholder' => "Waiting Time"])->label(false);
?>
            </div>   
        </div>

        <div class="col-lg-4 col-sm-4">
            <div class="fieldBox phone">
                
<?php
echo $form->field($model, 'userNumber')->textInput()->input('text', ['placeholder' => "Phone No"])->label(false);
?>
            </div>   
        </div>

        <div class="col-lg-4 col-sm-4">
            <div class="fieldBox date-book">
                <div class="styled-select slate">

<?php echo $form->field($model, 'userVip')->dropDownList(['' => 'Select Customer Category', '0' => 'Normal', '1' => 'VIP'])->label(false); ?>
                </div>
            </div>  
        </div>
        

        <div class="col-lg-4 col-sm-4">
            <div class="fieldBox date-book">
                <div class="styled-select slate">
            <?php
            $currUserId = Yii::$app->user->getId();
            $currentuserId = isset($currUserId) ? $currUserId : '0';
            $items = ArrayHelper::map(Restaurant::find()->joinWith(['userRestaurantManages'])
            ->where(['user_restaurant_manage.fkUserRestaurantOwnerID' => $currentuserId])->all(), 'pkRestaurantID', 'restaurantName');
          
    echo $form->field($model, 'fkRestaurantID')->dropdownList($items,
    ['prompt'=>'Select Restaurant'])->label(false);     
    ?>               
                </div>
            </div>  
        </div>

        <div class="col-lg-4 col-sm-4">
            <div class="btnBox">
              <input class="btn" value="Search" type="submit">
                <?php  //echo Html::submitButton('Search', ['class' => 'btn']) ?>
                <?php  //echo Html::a('Reset',  ['user-restaurant-booking/index']) ?>
            </div> 
        </div>
    </div>
<?php ActiveForm::end(); ?>
</div>

backend/views/user-restaurant-booking/_searchTransaction.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use yii\helpers\ArrayHelper;
use backend\models\Restaurant;

/* @var $this yii\web\View */
/* @var $model backend\models\SearchReservations */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="content-area search-bookig">
    <h2>Search</h2>

    <?php
    $form = ActiveForm::begin([
                'action' => ['transactions'],
                'method' => 'get',
    ]);
    ?>
    <div class="row">
        <div class="col-lg-4 col-sm-4">
            <div class="fieldBox calender-box">

<?php
echo $form->field($model, 'fromDate')->textInput()->input('text', ['placeholder' => "From",'id' => 'datepickerFrom'])->label(false);
?>
            </div>
        </div>

        <div class="col-lg-4 col-sm-4">
            <div class="fieldBox calender-box">

<?php
echo $form->field($model, 'toDate')->textInput()->input('text', ['placeholder' => "To",'id' => 'datepickerTo'])->label(false);
?>
            </div>   
        </div>

        <div class="col-lg-4 col-sm-4">
            <div class="fieldBox name">

<?php
echo $form->field($model, 'userName')->textInput()->input('text', ['placeholder' => "Reservation Name"])->label(false);
?>

            </div>   
        </div>

        <div class="col-lg-4 col-sm-4">
            <div class="fieldBox phone">
                
<?php
echo $form->field($model, 'userNumber')->textInput()->input('text', ['placeholder' => "Phone No"])->label(false);
?>
            </div>   
        </div>
       

        <div class="col-lg-4 col-sm-4">
            <div class="fieldBox date-book">
                <div class="styled-select slate">
            <?php
            $currUserId = Yii::$app->user->getId();
            $currentuserId = isset($currUserId) ? $currUserId : '0';
            $items = ArrayHelper::map(Restaurant::find()->joinWith(['userRestaurantManages'])
            ->where(['user_restaurant_manage.fkUserRestaurantOwnerID' => $currentuserId])->all(), 'pkRestaurantID', 'restaurantName');
          
    echo $form->field($model, 'fkRestaurantID')->dropdownList($items,
    ['prompt'=>'Select Restaurant'])->label(false);     
    ?>               
                </div>
            </div>  
        </div>

        <div class="col-lg-4 col-sm-4">
            <div class="btnBox">
              <input class="btn" value="Search" type="submit">
                <?php  //echo Html::submitButton('Search', ['class' => 'btn']) ?>
                <?php  //echo Html::a('Reset',  ['user-restaurant-booking/index']) ?>
            </div> 
        </div>
    </div>
<?php ActiveForm::end(); ?>
</div>

backend/views/user-restaurant-booking/create.php
<?php

use yii\helpers\Html;


/* @var $this yii\web\View */
/* @var $model backend\models\UserRestaurantBooking */

$this->title = Yii::t('app', 'Create Restaurant Booking');
//$this->params['breadcrumbs'][] = ['label' => 'User Restaurant Bookings', 'url' => ['index']];
//$this->params['breadcrumbs'][] = $this->title;
?>
    <!-- <h1><?= Html::encode($this->title) ?></h1> -->
    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

backend/views/user-restaurant-booking/transaction.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;
use backend\models\RestaurantLocation;

/* @var $this yii\web\View */
/* @var $searchModel backend\models\UserRestaurantBookingSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

//$this->title = 'Manage Reservation';
//$this->params['breadcrumbs'][] = $this->title;
?>
<div class="col-sm-9 col-sm-offset-3 col-md-10 col-md-offset-2 main">
<h1>Transactions</h1>
     <!-- <h1><?= Html::encode($this->title) ?></h1> -->
    <?php  echo $this->render('_searchTransaction', ['model' => $searchModel]); ?>
    <div class="total-bookigs">

   <div class="booking-list">

            <div class="table-responsive">
    <?=
                GridView::widget([
                    'dataProvider' => $dataProvider,
                    //'filterModel' => $searchModel,
                    'columns' => [
                        ['class' => 'yii\grid\SerialColumn'],
                        [
                            'attribute' => 'Transaction ID',
                            'value' => 'pkUserRestaurantBookingID'
                        ],
                        [
                            'attribute' => 'Date',
                            'value' => 'date',
                            'format' => ['date', 'php:d-M-Y']
                        ],
                        [
                            'attribute' => 'Reservation Person',
                            'value' => 'fkUser.userName',
                        ],
                        [
                            'attribute' => 'Restaurant',
                            'value' => function($dataProvider){
                                $locationName = RestaurantLocation::findOne(['pkRestaurantLoactionID' => $dataProvider->fkRestaurant->restaurantLocationID]);
                                return $dataProvider->fkRestaurant->restaurantName.' ('.$locationName->locationName.')';
                            },
                        ],
                        [
                            'attribute' => 'Phone No',
                            'value' => 'fkUser.userNumber',
                        ],
                        [
                            'attribute' => 'Email',
                            'value' => 'fkUser.userEmail',
                        ],
                       // ['class' => 'yii\grid\ActionColumn'],
                        ['class' => 'yii\grid\ActionColumn', 'template' => '{view}'],
                    ],
                ]);
                ?>
</div>
</div>

<div class="coptyright">BuzzQ © 2016. All Rights Reserved.</div>
    </div>
</div>

backend/views/user-restaurant-booking/update.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model backend\models\UserRestaurantBooking */

$this->title = 'Update User Restaurant Booking: ' . $model->pkUserRestaurantBookingID;
$this->params['breadcrumbs'][] = ['label' => 'User Restaurant Bookings', 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->pkUserRestaurantBookingID, 'url' => ['view', 'id' => $model->pkUserRestaurantBookingID]];
$this->params['breadcrumbs'][] = 'Update';
?>
<div class="user-restaurant-booking-update">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>